#include <cstdlib>
#include <iostream>

#include "git.h"
#include "cmake.h"

const char *version = "version info:\n";

bool GitMetadata::Populated() {
    return false;
}
bool GitMetadata::AnyUncommittedChanges() {
    return false;
}
std::string GitMetadata::AuthorName() {
    return "";
}
std::string GitMetadata::AuthorEmail() {
    return "";
}
std::string GitMetadata::CommitSHA1() {
    return "";
}
std::string GitMetadata::CommitDate() {
    return "";
}
std::string GitMetadata::CommitSubject() {
    return "";
}
std::string GitMetadata::CommitBody() {
    return "";
}
std::string GitMetadata::Describe() {
    return "unknown";
}
std::string GitMetadata::Branch() {
    return "HEAD";
}
__attribute__ ((visibility ("default"))) void GitMetadata::VersionInfo() {
   std::cout << PROJECT_NAME << ": " << PROJECT_VER << std::endl;

   if(GitMetadata::Populated()) {
        if(GitMetadata::AnyUncommittedChanges()) {
            std::cerr << "\t" << "WARN: there were uncommitted changes at build-time." << std::endl;
        }
        std::cout << "\t" << "commit " << GitMetadata::CommitSHA1() << " (" << GitMetadata::Branch() << ")\n"
                  << "\t" << "describe " << GitMetadata::Describe() << "\n"
                  << "\t" << "Author: " << GitMetadata::AuthorName() << " <" << GitMetadata::AuthorEmail() << ">\n"
                  << "\t" << "Date: " << GitMetadata::CommitDate() << "\n\n"
                  << "\t" << GitMetadata::CommitSubject() << "\n" << GitMetadata::CommitBody() << std::endl;
    }
    else {
#ifdef MANUAL_GITINFO
        std::cerr << "INFO: manual git info: " << MANUAL_GITINFO << std::endl;
#else
        std::cerr << "WARN: no manual git info defined " << std::endl;
#endif
    }
}

